详解面试中常被问到的那些异常问题

Java中异常相关的问题一直作为面试中的高频题目,虽然是一个比较基础的知识点,但是在梳理的过程中还是有很多收货,温故知新。希望也能给大家带来一些帮助。

什么是异常?

所有使我们程序提前终止,或者没有向预想方向去执行的错误统称为异常。

异常的分类

所有异常都由 Throwable 继承而来,即 ExceptionError 都继承自 Throwable

注:Java中只有Throwable类型的实例才可以被抛出(throw)或者捕获(try..catch)

Error

Error是指在正常情况下不太可能出现的错误,它与代码的编写无关。通常是表示运行时JVM出现的问题,比如系统内部错误、或者资源不足等。

常见的有: OutOfMemoryError ( 内存溢出 ) 、  VirtualMachineError (虚拟机错误)、  NoClassDefFoundError (类定义错误)

Exception

Exception是指程序运行时,可以预料到的错误, Exception 又分为以下两类

  • 可检查异常 (Exception)

    需要我们在程序中必须进行显式的捕获处理,否则将会编译报错,比如常见的有IOException、SQLException

如下,是一个文件逐行读取的方法,如不进行异常处理,则编译报错。

try {
Thread.sleep(10);
} catch (InterruptedException e) {
e.printStackTrace();
}
public static void readFile(String fileName) {
File file = new File(fileName);
BufferedReader br = null;
try {
br = new BufferedReader(new FileReader(file));
int line = 1;
// 按行读取
while (br.readLine() != null) {
System.out.println(br.readLine());
line++;
}
} catch (IOException e) {
e.printStackTrace();
}
finally {
if (br != null) {
try {
br.close();
} catch (IOException e) {
e.printStackTrace();
}
}
}
}
  • 不可检查异常 ( RuntimeException )

    常见的有 NullPointerException (空指针)、 ArrayIndexOutOfBoundException (下标越界异常)。是否需要去捕捉,程序本身不要求我们强制去做这些。但是可以避免代码在运行过程中的逻辑错误。

如下,从集合中提取元素,本身不需要我们去进行异常捕捉,但是在运行的时候会报 NullPointerException 异常

List<String> lst = Arrays.asList("A", "B", "C");
String str = lst.get(3);

注:

阿里Java开发手册中提到,如果可以进行预检测的RuntimeException不应该通过catch的方法进行处理。比如NullPointExceotion。可以先进行非控的判断,比如if(obj != null){…}

看了上面的内容,也就很轻松的去应对面试官问的问题 『Exception和Error有什么区别?』 当然,异常处理常作为面试过程中的夺命连环call。为了方便加深上面问题的答案,从网上找到了一张图。

详解面试中常被问到的那些异常问题

异常的处理

代码中的异常处理主要针对可检查异常。、

通过try…catch 语句来处理

try {
// 需要捕获的代码
} catch (Exception e1) {
// catch代码块
}
finally {
// 无论是否发生异常,都会执行的代码块
}

当try中代码块发生异常后,会执行catch代码块。但是无论如何,最终finally中的代码块一定会被执行,比如可以去做一些资源回收的工作。

2、通过throws/throw将异常抛出交给上层处理

  • throws

    用来声明一个方法可能产生的所有异常(并不一定会产生异常),不做任何处理就将异常往上传给调用者。

    用来方法声明后面,多个异常用逗号隔开,

  • public String getValue(List list,int num) throws Exception{
    return (String) list.get(num);
    }
    
  • throw

    用来抛出一个具体的异常类型

    只是抛出异常对象吗,用在方法体内。一定会抛出异常。

  1. public static void main(String[] args) {

  2. try {

  3. throwNumException(11);

  4. } catch (Exception e) {

  5. System.out.println(e.getMessage());

  6. }

  7. }

  8. public static void throwNumException(int a) throws Exception{

  9. if (a > 10) {

  10. throw new Exception("a的数值不符合要求");

  11. }

  12. }

异常处理注意事项

1、谨慎使用异常处理

try..catch会造成程序的额外开销,所以建议只捕获关键的代码,切忌不要用try包住一个很大的代码块。

Java每实例化一个Exception,就会对当时的栈进行快照。如果操作比较频繁,那么对资源的开销就不能被忽略。

2、在finally代码块中对资源进行清理

如下代码,正常执行时没有任何问题,但是在关闭资源之前一旦出现异常,就会造成资源无法释放。

File file = new File(fileName);
BufferedReader br = null;
try {
br = new BufferedReader(new FileReader(file));
// ignore 逻辑处理
br.close(); //关闭资源
} catch (IOException e) {
e.printStackTrace();
}

正确写法:

try {
br = new BufferedReader(new FileReader(file));
// ignore 逻辑处理
} catch (IOException e) {
e.printStackTrace();
}
finally {
if (br != null) {
try {
br.close();
} catch (IOException e) {
e.printStackTrace();
}
}
}

3、指定具体的异常

以下代码在执行上并没有什么问题,但是捕获了一个通用异常Exception,正确写法应该捕获特定的异常。

Thread.sleep() 抛出的是InterruptedException。

try {
Thread.sleep(10);
} catch (Exception e) {
e.printStackTrace();
}

在日常开发中,我们往往需要更直观的去观察异常,如果抛出多个异常,都用通用异常去捕获,这样就很那去定位问题的所在了。更严格的写法应该如下所示

try {
// ignore 逻辑代码
Thread.sleep(10);
} catch (InterruptedException e) {
e.printStackTrace();
} catch (Exception e) {
e.printStackTrace();
}

(以下几点摘自泰山版阿里开发手册,可以在公众号“Java专栏”后台回复 【阿里】)获取

4、不要用异常做流程控制,条件控制

异常设计的初衷是为了解决程序运行中的各种意外情况,切异常处理的效率比条件判断的要低很多

5、catch时,请分清稳定代码和不稳定代码

稳定代码指的是无论如果都不会再出错的代码,对于非稳定代码进行catch时,尽可能区分异常类型,再做对应的异常处理。

6、捕获就要处理

捕获异常是为了处理它,不要捕获了却什么都不处理而抛弃之,如果不想处理它,请

将该异常抛给它的调用者。最外层的业务使用者,必须处理异常,将其转化为用户可以理解的

内容。

面试

以上基本包含了常见的面试题答案,另外常见的一个面试题还有 finally和try中的return哪个先执行?

可以先看看下面几个例子

1、

public static int getNum() {
int a = 10;
try {
System.out.println("进入try");
return a;
} catch (Exception e) {
e.printStackTrace();
return a;
}
finally {
a = 20;
System.out.println("a的值为:" + a);
}
}

执行结果:

进入try
a的值为:20
10

结论:可以看出,进入try之后,在return之前执行了finally代码块的代码

2、

  1. public static void main(String[] args) {

  2. System.out.println(getNum());

  3. }

  4. public static int getNum() {

  5. int a = 10;

  6. try {

  7. System.out.println("执行try");

  8. //ignore

  9. System.out.println("即将return");

  10. return a;

  11. } catch (Exception e) {

  12. e.printStackTrace();

  13. return a;

  14. }

  15. finally {

  16. System.out.println("开始执行finally");

  17. a = 20;

  18. System.out.println("执行finally结束");

  19. }

  20. }

运行结果:

执行try
即将return
开始执行finally
执行finally结束
10

执行结果打印了10 ,似乎finally里中对a的修改并没有起到作用。在JVM规范中有这样写道

If the try clause executes a return, the compiled code does the following:
1. Saves the return value (if any) in a local variable.
2. Executes a jsr to the code for the finally clause.
3. Upon return from the finally clause, returns the value saved in the local variable.

如果在try中return的情况下,先把try中将要return的值先存到一个本地变量中 ,即上面例子中的x=10将会被保存下来。接下来去执行finally语句,最后返回的是存在本地变量中的值,即返回x=10.

3、

public static int getNum() {
int a = 10;
try {
return a;
} catch (Exception e) {
e.printStackTrace();
return a;
}
finally {
a = 20;
return a;
}
}

执行结果:

结论:如果finally中有return则会忽略try中的return

注:阿里开发手册中指出,不要再finally中使用return

总结

  • try中有return, 会先将值暂存,无论finally语句中对该值做什么处理,最终返回的都是try语句中的暂存值。

  • 当try与finally语句中均有return语句,会忽略try中return。

详解面试中常被问到的那些异常问题

长按关注,还原真实面试现场!

原文 

http://mp.weixin.qq.com/s?__biz=Mzg3MjA4MTExMw==&mid=2247491351&idx=2&sn=363ebce190ac97a9e0a9ca0996853445

本站部分文章源于互联网,本着传播知识、有益学习和研究的目的进行的转载,为网友免费提供。如有著作权人或出版方提出异议,本站将立即删除。如果您对文章转载有任何疑问请告之我们,以便我们及时纠正。

PS:推荐一个微信公众号: askHarries 或者qq群:474807195,里面会分享一些资深架构师录制的视频录像:有Spring,MyBatis,Netty源码分析,高并发、高性能、分布式、微服务架构的原理,JVM性能优化这些成为架构师必备的知识体系。还能领取免费的学习资源,目前受益良多

转载请注明原文出处:Harries Blog™ » 详解面试中常被问到的那些异常问题

赞 (0)
分享到:更多 ()

评论 0

  • 昵称 (必填)
  • 邮箱 (必填)
  • 网址